// ----- SHARED ----- //

$color-bg-1: #1e3043;
$color-bg-2: #f0f0f0;
$color-bg-3: #f7f7f7;
$color-bg-4: #01b9ac;
$color-bg-5: white;

$color-border-1: #d2d6d8;

$color-brand-1: #32eccb;
$color-brand-2: #05b8ac;
$color-brand-3: #1b7f8b;
$color-brand-4: #1f3042;

$color-font-1: #1e3043;
$color-font-2: #4d5b66;
$color-font-3: #a6acb3;
$color-font-4: #ffffff;

$font-root-size: 15px;
$font-family-header: 'Barlow', Helvetica, Arial, sans-serif;
$font-family-body: 'Barlow', Helvetica, Arial, sans-serif;

$sizing-breakpoint-xxxl: 1440px;
$sizing-breakpoint-xxl: 1280px;
$sizing-breakpoint-xl: 960px;
$sizing-breakpoint-l: 800px;
$sizing-breakpoint-m: 640px;
$sizing-breakpoint-s: 480px;
$sizing-breakpoint-xs: 320px;

$sizing-site-max-width: 1280px;
$sizing-page-margin-side: 1rem;

$sizing-border-radius: 0.25rem;
$sizing-border-radius-large: $sizing-border-radius * 2.5;

$box-shadow-default: 0 0 6px rgba(0, 0, 0, 0.05);

// ----- BASE ELEMENTS ----- //

%anchor {
  text-decoration: none;

  &:hover {
    opacity: 0.8;
  }
  &:active {
    opacity: 0.6;
  }
}

%btn {
  display: inline-block;
  border-width: 2px;
  border-style: solid;
  border-color: $color-brand-1;
  color: $color-font-3;
  text-decoration: none;
  user-select: none;
  white-space: nowrap;
  border-radius: $sizing-border-radius-large;
  padding: 0.8rem 1rem;
  cursor: pointer;
}

%card {
  display: flex;
  flex-direction: column;
  position: relative;
  width: 25rem;
  height: 35rem;
  margin: 0 2rem;
  border-radius: $sizing-border-radius;
  background: $color-bg-5;
  box-shadow: $box-shadow-default;
  text-align: center;
  overflow: hidden;
}

@mixin killLineBreakBelow($max-width) {
  @media (max-width: $max-width) {
    content: '';

    &::after {
      content: ' ';
    }
  }
}

%markdownBody {
  line-height: 1.5em;
  padding-top: 1rem;

  h1,
  h2,
  h3,
  h4,
  h5,
  h6 {
    font-family: $font-family-header;
    margin: 1em 0;
    color: $color-font-1;
    line-height: 1em;
    text-transform: unset;

    &:first-child {
      margin-top: 0;
    }
  }

  h1 {
    margin-top: 5rem;
    font-size: 1.75em;
    font-weight: bold;
  }

  h2 {
    margin-top: 4rem;
    font-size: 1.6em;
    font-weight: bold;
  }

  h3 {
    margin-top: 3rem;
    font-size: 1.45em;
    font-weight: bold;
  }

  h4 {
    margin-top: 2.5rem;
    font-size: 1.3em;
    font-weight: bold;
    color: $color-font-2;
  }

  h5 {
    margin-top: 2rem;
    font-size: 1.15em;
    font-weight: bold;
    color: $color-font-2;
  }

  h6 {
    margin-top: 1.5rem;
    font-size: 1em;
    font-weight: bold;
    color: $color-font-2;
  }

  blockquote {
    position: relative;
    font-style: italic;
    margin: 3rem 4rem;

    &::before {
      content: '';
      position: absolute;
      top: 0;
      left: -4rem;
      width: 0.3rem;
      bottom: 0;
      background: $color-brand-1;
    }

    cite {
      display: block;
      opacity: 0.5;

      &::before {
        content: '— ';
      }
    }
  }

  > img {
    display: block;
    margin: 3rem auto;
    max-width: 30rem;
    max-height: 20rem;
  }

  figure {
    display: block;
    margin-block: 0;
    margin-inline: 0;
    margin: 3rem auto;
    max-width: 40rem;

    :global .gatsby-resp-image-wrapper {
      background: $color-bg-2;
      box-shadow: $box-shadow-default;
      border: 1px solid $color-border-1;
      border-radius: $sizing-border-radius;
      overflow: hidden;
    }

    figcaption {
      text-align: center;
      font-size: 0.8em;
      font-style: italic;
      padding: 0.5rem;
      padding-bottom: 0;
      opacity: 0.5;
    }
  }

  %floater {
    margin: 1rem 2rem;
    max-width: 12rem;
    max-height: 12rem;

    @media (max-width: $sizing-breakpoint-s) {
      max-width: 6rem;
      max-height: 6rem;
    }

    @media (max-width: $sizing-breakpoint-m) {
      max-width: 8rem;
      max-height: 8rem;
    }

    @media (max-width: $sizing-breakpoint-l) {
      max-width: 10rem;
      max-height: 10rem;
    }
  }

  :global .left {
    @extend %floater;
    float: left;
    margin-left: 0;
  }

  :global .right {
    @extend %floater;
    float: right;
    margin-right: 0;
  }

  a {
    color: #0087ea;
    text-decoration: underline;
  }

  table {
    display: block;
    width: fit-content;
    max-width: 75rem;
    margin: 2rem auto;
    border-spacing: 0;
    border: 1px solid $color-bg-4;
    border-radius: $sizing-border-radius-large;
    box-shadow: $box-shadow-default;
    overflow-x: auto;

    thead,
    tbody {
      border-radius: inherit;
    }

    th,
    td {
      padding: 0.5rem 0.75rem;
      border-right: 1px solid $color-border-1;
      border-bottom: 1px solid $color-border-1;
      min-width: 10rem;

      &:first-child {
        border-left: 1px solid $color-bg-4;
        border-left: 0;
      }

      &:last-child {
        border-right-color: $color-bg-4;
        border-right: 0;
      }
    }

    th {
      font-weight: bold;
      color: $color-font-4;
      background: $color-bg-4;
      border-top-color: $color-bg-4;
      border-bottom-color: $color-bg-4;
    }

    tr:nth-child(odd) td {
      background: $color-bg-2;
    }

    tr:nth-child(even) td {
      background: $color-bg-3;
    }

    thead {
      tr:first-child {
        th {
          border-top: 0;
        }
      }
    }

    tbody {
      td:first-child {
        font-weight: bold;
      }

      tr:last-child {
        border-radius: inherit;

        td {
          border-bottom: 0;
        }

        td:first-child {
          border-bottom-left-radius: inherit;
        }

        td:last-child {
          border-bottom-right-radius: inherit;
        }
      }
    }
  }
}

// ----- ANIMATIONS ----- //

@keyframes bounce {
  0% {
    transform: translateY(0px);
  }
  80% {
    transform: translateY(0px);
  }
  85% {
    transform: translateY(-15px);
  }
  90% {
    transform: translateY(0px);
  }
  95% {
    transform: translateY(-5px);
  }
  100% {
    transform: translateY(0px);
  }
}
